part of katana_routing;

class UIModalRoute extends PageRoute<void> {
  UIModalRoute(
      {required this.builder,
      this.isAndroidBackEnable = true,
      required RouteSettings? settings,
      this.transitionDuration = const Duration(milliseconds: 300),
      this.opaque = false,
      this.barrierDismissible = false,
      this.barrierColor = const Color(0x80000000),
      this.barrierLabel,
      this.maintainState = true})
      : super(settings: settings, fullscreenDialog: true);

  final WidgetBuilder builder;
  final bool isAndroidBackEnable;
  @override
  final Duration transitionDuration;
  @override
  final bool opaque;
  @override
  final bool barrierDismissible;
  @override
  final Color? barrierColor;
  @override
  final String? barrierLabel;
  @override
  final bool maintainState;

  @override
  Widget buildPage(
    BuildContext context,
    Animation<double> animation,
    Animation<double> secondaryAnimation,
  ) {
    return Material(
      type: MaterialType.transparency,
      child: SafeArea(
        child: WillPopScope(
          onWillPop: () async {
            return isAndroidBackEnable;
          },
          child: Center(
            child: builder(context),
          ),
        ),
      ),
    );
  }

  @override
  Widget buildTransitions(BuildContext context, Animation<double> animation,
      Animation<double> secondaryAnimation, Widget child) {
    return FadeTransition(
      opacity: animation,
      child: ScaleTransition(
        scale: animation,
        child: child,
      ),
    );
  }
}
